"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.connect = void 0;

var _slingHelpers = require("sling-helpers");

var _onSdkAccessible = require("./onSdkAccessible.js");

var connect = function connect(mapStateToProps, mapDispatchToProps) {
  return function () {
    var Base = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : HTMLElement;

    var ConnectedComponent =
    /*#__PURE__*/
    function (_Base) {
      _inherits(ConnectedComponent, _Base);

      function ConnectedComponent() {
        var _this;

        _classCallCheck(this, ConnectedComponent);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(ConnectedComponent).call(this));
        _this.handleStoreChange = _this.handleStoreChange.bind(_assertThisInitialized(_assertThisInitialized(_this)));
        return _this;
      }

      _createClass(ConnectedComponent, [{
        key: "handleStoreChange",
        value: function handleStoreChange($sdk) {
          var _this2 = this;

          var state = $sdk.store.getState();
          var dispatch = $sdk.store.dispatch;
          var newProps = (0, _slingHelpers.isFunction)(mapStateToProps) ? mapStateToProps(state, this) : {};
          var newActions = (0, _slingHelpers.isFunction)(mapDispatchToProps) ? mapDispatchToProps(dispatch, this) : {};
          Object.entries(_objectSpread({}, newProps, newActions)).forEach(function (_ref) {
            var _ref2 = _slicedToArray(_ref, 2),
                prop = _ref2[0],
                value = _ref2[1];

            if (!(0, _slingHelpers.isFunction)(_this2[prop])) {
              _this2[prop] = value;
            }
          });
        }
      }, {
        key: "connectedCallback",
        value: function connectedCallback() {
          var _this3 = this;

          if ((0, _slingHelpers.isFunction)(_get(_getPrototypeOf(ConnectedComponent.prototype), "connectedCallback", this))) {
            _get(_getPrototypeOf(ConnectedComponent.prototype), "connectedCallback", this).call(this);
          }

          (0, _onSdkAccessible.onSdkAccessible)().then(function ($sdk) {
            _this3.unsubscribe = $sdk.store.subscribe(function () {
              _this3.handleStoreChange($sdk);
            });

            _this3.handleStoreChange($sdk);
          });
        }
      }, {
        key: "disconnectedCallback",
        value: function disconnectedCallback() {
          if ((0, _slingHelpers.isFunction)(_get(_getPrototypeOf(ConnectedComponent.prototype), "disconnectedCallback", this))) {
            _get(_getPrototypeOf(ConnectedComponent.prototype), "disconnectedCallback", this).call(this);
          }

          if ((0, _slingHelpers.isFunction)(this.unsubscribe)) {
            this.unsubscribe();
          }
        }
      }]);

      return ConnectedComponent;
    }(Base);

    return ConnectedComponent;
  };
};

exports.connect = connect;