"use strict";

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeRequest = exports.defaultErrorHandler = exports.defaultBodyParser = exports.defaultResponseParser = exports.defaultStatusChecker = void 0;

var defaultStatusChecker = function defaultStatusChecker(response) {
  return response.ok;
};

exports.defaultStatusChecker = defaultStatusChecker;

var defaultResponseParser = function defaultResponseParser(response) {
  return response.status !== 204 ? response.json() : response;
};

exports.defaultResponseParser = defaultResponseParser;

var defaultBodyParser = function defaultBodyParser(body) {
  return JSON.stringify(body);
};

exports.defaultBodyParser = defaultBodyParser;

var defaultErrorHandler = function defaultErrorHandler(error) {
  return error;
};

exports.defaultErrorHandler = defaultErrorHandler;

var makeRequest = function makeRequest(url) {
  var requestParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var requestConfig = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var fetchMaker = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : fetch;
  var _requestConfig$status = requestConfig.statusChecker,
      statusChecker = _requestConfig$status === void 0 ? defaultStatusChecker : _requestConfig$status,
      _requestConfig$respon = requestConfig.responseParser,
      responseParser = _requestConfig$respon === void 0 ? defaultResponseParser : _requestConfig$respon,
      _requestConfig$bodyPa = requestConfig.bodyParser,
      bodyParser = _requestConfig$bodyPa === void 0 ? defaultBodyParser : _requestConfig$bodyPa,
      _requestConfig$errorH = requestConfig.errorHandler,
      errorHandler = _requestConfig$errorH === void 0 ? defaultErrorHandler : _requestConfig$errorH;
  var body = requestParams.body;
  var requestParamsWithParsedBody = requestParams;

  if (body != null) {
    requestParamsWithParsedBody = _objectSpread({}, requestParams, {
      body: bodyParser(body)
    });
  }

  return fetchMaker(url, requestParamsWithParsedBody).then(function (response) {
    if (statusChecker(response) === true) {
      return responseParser(response);
    }

    throw errorHandler(response);
  }).catch(function (error) {
    throw errorHandler(error);
  });
};

exports.makeRequest = makeRequest;