"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getPaymentOperationsCategoriesInfo = exports.getPaymentStatusInfo = exports.getPaymentWalletTypesInfo = exports.getPaymentOperationsInfo = exports.getPaymentDetailsInfoByWalletTypeId = exports.getPaymentDetailsInfo = exports.getCalendarPaymentsInfo = void 0;

var paymentsService = _interopRequireWildcard(require("../../core/services/paymentsService.js"));

var transactionsService = _interopRequireWildcard(require("../../core/services/transactionsService.js"));

var paymentsModel = _interopRequireWildcard(require("../../models/paymentsModels.js"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

const {
  getProductTypes,
  getBrands
} = transactionsService;
const {
  getPaymentDetailsByWalletTypeId,
  getPaymentDetails,
  getPaymentStatus,
  getPaymentOperations,
  getPaymentWalletTypes,
  getPaymentOperationsCategories
} = paymentsService;
const {
  paymentsCalendarModel,
  paymentDetailsModel,
  paymentDetailsByWalletTypeIdModel
} = paymentsModel;

const getCalendarPaymentsInfo = (requestParams, instance) => dispatch => {
  const promises = [getPaymentDetails({ ...requestParams,
    crossbalance: true
  }, instance), getPaymentStatus(requestParams, instance)];
  Promise.all(promises).then(responses => {
    dispatch({
      type: 'GET_PAYMENTS_CALENDAR_INFO',
      data: paymentsCalendarModel(responses)
    });
  });
};

exports.getCalendarPaymentsInfo = getCalendarPaymentsInfo;

const getPaymentDetailsInfo = (requestParams, instance) => dispatch => {
  const promises = [getPaymentDetails({ ...requestParams,
    crossbalance: true
  }, instance), getPaymentWalletTypes(requestParams, instance), getBrands(requestParams, instance), getProductTypes(requestParams, instance)];
  Promise.all(promises).then(responses => {
    dispatch({
      type: 'GET_PAYMENT_DETAILS_INFO',
      data: paymentDetailsModel(responses)
    });
  });
};

exports.getPaymentDetailsInfo = getPaymentDetailsInfo;

const getPaymentDetailsInfoByWalletTypeId = (requestParams, instance) => dispatch => {
  const promises = [getPaymentDetailsByWalletTypeId(requestParams, instance), getPaymentWalletTypes(requestParams, instance), getPaymentOperationsCategories(requestParams, instance), getBrands(requestParams, instance), getProductTypes(requestParams, instance)];
  Promise.all(promises).then(responses => {
    dispatch({
      type: 'GET_PAYMENT_DETAILS_INFO_BY_WALLET_TYPE_ID',
      data: paymentDetailsByWalletTypeIdModel(responses)
    });
  });
};

exports.getPaymentDetailsInfoByWalletTypeId = getPaymentDetailsInfoByWalletTypeId;

const getPaymentOperationsInfo = (requestParameters, instance) => dispatch => {
  const promises = [getPaymentOperations(requestParameters, instance), getPaymentStatus(requestParameters, instance), getPaymentOperationsCategories(requestParameters, instance), getProductTypes(requestParameters, instance)];
  Promise.all(promises).then(responses => {
    dispatch({
      type: 'GET_PAYMENT_OPERATIONS_INFO',
      data: paymentsModel.paymentOperationsModel(responses)
    });
  });
};

exports.getPaymentOperationsInfo = getPaymentOperationsInfo;

const getPaymentWalletTypesInfo = (requestParameters, instance) => dispatch => {
  paymentsService.getPaymentWalletTypes(requestParameters, instance).then(response => {
    dispatch({
      type: 'GET_PAYMENT_WALLET_TYPES',
      data: paymentsModel.paymentsWalletsTypesModel(response)
    });
  });
};

exports.getPaymentWalletTypesInfo = getPaymentWalletTypesInfo;

const getPaymentStatusInfo = (requestParameters, instance) => dispatch => {
  paymentsService.getPaymentStatus(requestParameters, instance).then(response => {
    dispatch({
      type: 'GET_PAYMENT_STATUS',
      data: paymentsModel.paymentsStatusModel(response)
    });
  });
};

exports.getPaymentStatusInfo = getPaymentStatusInfo;

const getPaymentOperationsCategoriesInfo = (requestParameters, instance) => dispatch => {
  paymentsService.getPaymentOperationsCategories(requestParameters, instance).then(response => {
    dispatch({
      type: 'GET_PAYMENT_OPERATIONS_CATEGORIES',
      data: paymentsModel.paymentsOperationsCategoriesModel(response)
    });
  });
};

exports.getPaymentOperationsCategoriesInfo = getPaymentOperationsCategoriesInfo;