"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getPaymentOperationsCategories = exports.getPaymentStatus = exports.getPaymentWalletTypes = exports.getPaymentOperations = exports.getPaymentDetailsByWalletTypeId = exports.getPaymentDetails = void 0;

var _index = require("./index.js");

var sdk = _interopRequireWildcard(require("../../v0/src/index.js"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

const getPaymentDetails = (requestParams, instance) => {
  const {
    apitoken,
    stonecode: affiliationCodes,
    startdate: startDate,
    finaldate: finalDate,
    crossbalance: crossBalance
  } = requestParams;
  return (0, _index.sdkRequest)(() => sdk.payments.payments.get({
    affiliationCodes,
    startDate,
    finalDate,
    crossBalance
  }), instance, apitoken);
};

exports.getPaymentDetails = getPaymentDetails;

const getPaymentDetailsByWalletTypeId = (requestParams, instance) => {
  const {
    apitoken,
    stonecode: affiliationCodes,
    startdate: startDate,
    finaldate: finalDate,
    wallettypeid: walletTypeId
  } = requestParams;
  return (0, _index.sdkRequest)(() => sdk.payments.details.get({
    affiliationCodes,
    startDate,
    finalDate,
    walletTypeId
  }), instance, apitoken);
};

exports.getPaymentDetailsByWalletTypeId = getPaymentDetailsByWalletTypeId;

const getPaymentOperations = (requestParams, instance) => {
  const {
    apitoken,
    stonecode: affiliationCodes,
    startdate: startDate,
    finaldate: finalDate,
    page,
    pagesize: pageSize
  } = requestParams;
  return (0, _index.sdkRequest)(() => sdk.payments.operations.get({
    affiliationCodes,
    startDate,
    finalDate,
    page,
    pageSize
  }), instance, apitoken);
};

exports.getPaymentOperations = getPaymentOperations;

const getPaymentWalletTypes = ({
  apitoken
}, instance) => (0, _index.sdkRequest)(() => sdk.payments.walletTypes.get(), instance, apitoken);

exports.getPaymentWalletTypes = getPaymentWalletTypes;

const getPaymentStatus = ({
  apitoken
}, instance) => (0, _index.sdkRequest)(() => sdk.payments.status.get(), instance, apitoken);

exports.getPaymentStatus = getPaymentStatus;

const getPaymentOperationsCategories = ({
  apitoken
}, instance) => (0, _index.sdkRequest)(() => sdk.payments.operationsCategories.get(), instance, apitoken);

exports.getPaymentOperationsCategories = getPaymentOperationsCategories;