"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.subscriptions = exports.simulateSales = exports.partners = exports.merchant = exports.fees = exports.contactTypes = exports.contacts = exports.bankAccounts = exports.availableBanks = exports.addresses = void 0;

var _addresses = require("./addresses/addresses.js");

var _availableBanks = require("./availableBanks/availableBanks.js");

var _bankAccounts = require("./bankAccounts/bankAccounts.js");

var _contacts = require("./contacts/contacts.js");

var _contactTypes = require("./contactTypes/contactTypes.js");

var _fees = require("./fees/fees.js");

var _merchant = require("./merchant/merchant.js");

var _partners = require("./partners/partners.js");

var _simulateSales = require("./simulateSales/simulateSales.js");

var _subscriptions = require("./subscriptions/subscriptions.js");

const addresses = (0, _addresses.service)();
exports.addresses = addresses;
const availableBanks = (0, _availableBanks.service)();
exports.availableBanks = availableBanks;
const bankAccounts = (0, _bankAccounts.service)();
exports.bankAccounts = bankAccounts;
const contacts = (0, _contacts.service)();
exports.contacts = contacts;
const contactTypes = (0, _contactTypes.service)();
exports.contactTypes = contactTypes;
const fees = (0, _fees.service)();
exports.fees = fees;
const merchant = (0, _merchant.service)();
exports.merchant = merchant;
const partners = (0, _partners.service)();
exports.partners = partners;
const simulateSales = (0, _simulateSales.service)();
exports.simulateSales = simulateSales;
const subscriptions = (0, _subscriptions.service)();
exports.subscriptions = subscriptions;