import { sdkRequest } from './index.js';
import * as sdk from '../../v0/src/index.js';
export var getPaymentDetails = function getPaymentDetails(requestParams, instance) {
  var apitoken = requestParams.apitoken,
      affiliationCodes = requestParams.stonecode,
      startDate = requestParams.startdate,
      finalDate = requestParams.finaldate,
      crossBalance = requestParams.crossbalance;
  return sdkRequest(function () {
    return sdk.payments.payments.get({
      affiliationCodes: affiliationCodes,
      startDate: startDate,
      finalDate: finalDate,
      crossBalance: crossBalance
    });
  }, instance, apitoken);
};
export var getPaymentDetailsByWalletTypeId = function getPaymentDetailsByWalletTypeId(requestParams, instance) {
  var apitoken = requestParams.apitoken,
      affiliationCodes = requestParams.stonecode,
      startDate = requestParams.startdate,
      finalDate = requestParams.finaldate,
      walletTypeId = requestParams.wallettypeid;
  return sdkRequest(function () {
    return sdk.payments.details.get({
      affiliationCodes: affiliationCodes,
      startDate: startDate,
      finalDate: finalDate,
      walletTypeId: walletTypeId
    });
  }, instance, apitoken);
};
export var getPaymentOperations = function getPaymentOperations(requestParams, instance) {
  var apitoken = requestParams.apitoken,
      affiliationCodes = requestParams.stonecode,
      startDate = requestParams.startdate,
      finalDate = requestParams.finaldate,
      page = requestParams.page,
      pageSize = requestParams.pagesize;
  return sdkRequest(function () {
    return sdk.payments.operations.get({
      affiliationCodes: affiliationCodes,
      startDate: startDate,
      finalDate: finalDate,
      page: page,
      pageSize: pageSize
    });
  }, instance, apitoken);
};
export var getPaymentWalletTypes = function getPaymentWalletTypes(_ref, instance) {
  var apitoken = _ref.apitoken;
  return sdkRequest(function () {
    return sdk.payments.walletTypes.get();
  }, instance, apitoken);
};
export var getPaymentStatus = function getPaymentStatus(_ref2, instance) {
  var apitoken = _ref2.apitoken;
  return sdkRequest(function () {
    return sdk.payments.status.get();
  }, instance, apitoken);
};
export var getPaymentOperationsCategories = function getPaymentOperationsCategories(_ref3, instance) {
  var apitoken = _ref3.apitoken;
  return sdkRequest(function () {
    return sdk.payments.operationsCategories.get();
  }, instance, apitoken);
};