import { matchesInterfacePartially, matchesInterface } from 'sling-helpers';
import { PATCH } from '../constants/constants.js';
export var validatePayload = function validatePayload(intface, payload, requestMethod) {
  var interfaceMatcher = requestMethod === PATCH ? matchesInterfacePartially : matchesInterface;
  var isInterfaceMatched = interfaceMatcher(intface);
  var isValidPayload = Array.isArray(payload) ? payload.every(isInterfaceMatched) : isInterfaceMatched(payload);

  if (!isValidPayload) {
    throw new Error('The object does not match the interface.');
  }

  return payload;
};