import { mapByKey } from 'sling-helpers';

export const salesReportModel = (responses) => {
  const [
    salesReport,
    brands,
    productTypes,
  ] = responses;

  const productTypeMap = mapByKey(productTypes.data, 'id', 'name');
  const brandsMap = mapByKey(brands.data, 'id', 'name');

  return salesReport.data.map((sale) => {
    sale.productTypeName = productTypeMap[sale.productTypeId];
    sale.brandName = brandsMap[sale.brandId];
    return sale;
  });
};
