import { matchesInterfacePartially, matchesInterface } from 'sling-helpers';
import { PATCH } from '../constants/constants.js';

export const validatePayload = (intface, payload, requestMethod) => {
  const interfaceMatcher = (requestMethod === PATCH)
    ? matchesInterfacePartially
    : matchesInterface;

  const isInterfaceMatched = interfaceMatcher(intface);

  const isValidPayload = Array.isArray(payload)
    ? payload.every(isInterfaceMatched)
    : isInterfaceMatched(payload);

  if (!isValidPayload) {
    throw new Error('The object does not match the interface.');
  }
  return payload;
};
