import { matchesInterface } from 'sling-helpers';
import { AddressesInterface } from './addressesInterface.js';

describe('Addresses Interfaces', () => {
  it('Should validate the payload according to the interface.', () => {
    const payload = {
      typeId: 1,
      entranceNumber: 1,
      streetName: 'test',
      neighborhood: 'test',
      postalCode: 'test',
      cityName: 'test',
      countrySubdivisionCode: 'test',
    };

    expect(matchesInterface(AddressesInterface)(payload))
      .to.be.equal(true);
  });

  it('Should pass with null agencyNumberVerificationCode.', () => {
    const payload = {
      typeId: 1,
      entranceNumber: 1,
      streetName: 'test',
      neighborhood: 'test',
      postalCode: 'test',
      cityName: 'test',
      countrySubdivisionCode: 'test',
    };

    expect(matchesInterface(AddressesInterface)(payload))
      .to.be.equal(true);
  });
});
